package com.jqtx.windows.command;

import cn.hutool.core.util.ObjectUtil;
import com.alibaba.fastjson.JSON;
import com.jqtx.windows.common.exception.BizException;
import com.jqtx.windows.common.factory.RuntimeContextHolder;
import com.jqtx.windows.component.CreditComponent;
import com.jqtx.windows.component.enums.CreditResultStatusEnum;
import com.jqtx.windows.component.model.CreditModel;
import com.jqtx.windows.infrastructure.enums.ExceptionCodeEnum;
import com.jqtx.windows.web.request.GetCreditRequest;
import com.jqtx.windows.web.response.CreditDetailResponse;
import com.jqtx.windows.web.response.JsonResult;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class GetCreditCommand {
    @Autowired
    private CreditComponent creditComponent;
    public JsonResult getCredit(){
        CreditDetailResponse response = new CreditDetailResponse();
        String requestBody = RuntimeContextHolder.currentRuntimeContext().getRequestBody();
        GetCreditRequest request = JSON.parseObject(requestBody,GetCreditRequest.class);
        if(ObjectUtil.isNull(request) || StringUtils.isBlank(request.getOrderNo())){
            throw new BizException(ExceptionCodeEnum.PARAMS_NULL);
        }
        CreditModel credit = creditComponent.getByOrderNo(request.getOrderNo());
        if(ObjectUtil.isNotNull(credit)){
            throw new BizException(ExceptionCodeEnum.BIZ_CREDIT_NOT_FOUND_ERROR);
        }
        response.setStatus("0");
        if(CreditResultStatusEnum.PASS.name().equals(credit.getCreditResult())){
            response.setStatus("1");
        }
        if(CreditResultStatusEnum.REFUSED.name().equals(credit.getCreditResult())){
            response.setStatus("2");
        }
        return JsonResult.success();
    }


}
