package com.jqtx.windows.command;


import com.alibaba.fastjson.JSONObject;
import com.jqtx.windows.common.factory.AbstractCommand;
import com.jqtx.windows.common.factory.RuntimeContextHolder;
import com.jqtx.windows.component.model.GetSignContractModel;
import com.jqtx.windows.infrastructure.feign.IProtocalFeignService;
import com.jqtx.windows.web.response.JsonResult;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class SignContractCommand extends AbstractCommand {
    @Autowired
    private IProtocalFeignService iProtocalFeignService;


    @Override
    public JsonResult execute() {
        String requestBody = RuntimeContextHolder.currentRuntimeContext().getRequestBody();
        GetSignContractModel getSignContractModel = JSONObject.parseObject(requestBody, GetSignContractModel.class);
        JsonResult<String> rongdanPdf = iProtocalFeignService.getFilePathPdf(getSignContractModel.getLoanNo(), "rongdan");
        return rongdanPdf;
    }
}
