package com.jqtx.windows.common.factory;

import com.jqtx.windows.infrastructure.enums.ExceptionCodeEnum;
import com.jqtx.windows.web.response.JsonResult;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;


@Service
@Slf4j
public abstract class AbstractCommand{

    public JsonResult doAction(){
        try{
            return this.execute();
        }catch (Exception e){
            log.error("[处理异常:{}]",e.getMessage(),e);
        } finally {
            RuntimeContextHolder.clear();
        }
        return JsonResult.error(ExceptionCodeEnum.SYSTEM_ERROR);
    }

    public abstract JsonResult execute();


}
