package com.jqtx.windows.web.config;

import com.jqtx.windows.command.CreditSubmitCommand;
import com.jqtx.windows.command.LoanStatusCommand;
import com.jqtx.windows.command.LoanSubmitCommand;
import com.jqtx.windows.common.factory.AbstractCommand;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.CommandLineRunner;
import org.springframework.stereotype.Component;

import java.util.HashMap;

@Component
@Slf4j
public class RouterConfig implements CommandLineRunner {


    @Autowired
    private CreditSubmitCommand creditSubmitCommand;
    @Autowired
    private LoanSubmitCommand loanSubmitCommand;
    @Autowired
    private LoanStatusCommand loanStatusCommand;

    private static HashMap<String, AbstractCommand> commandHashMap = new HashMap<>();

    public static AbstractCommand getCommand(String method) {
        if (!commandHashMap.containsKey(method)) {
            return null;
        }
        return commandHashMap.get(method);
    }

    @Override
    public void run(String... args) throws Exception {
        commandHashMap.put("creditSubmit", creditSubmitCommand);
        commandHashMap.put("loanSubmit", loanSubmitCommand);
        commandHashMap.put("getLoanResult", loanStatusCommand);
    }
}
